/*
Compiler: BC++ 3.1, 
          Turbo C++ 1.01 (3.01)
          MSVC 1.52
      
Compile mode: large

Project: SD_QA.c 
         ..\..\lib\8000a.lib
         ..\lib\sd_vnnn.lib
         
Hardware: uPAC-5000

[Jan 05, 2012] by Liam
*/

#include <stdlib.h>
#include "..\..\Lib\8000a.h"			
#include "..\..\Lib\microSD.h"


typedef char *va_list;
typedef int acpi_native_int;
 
#define _AUPBND (sizeof (acpi_native_int) - 1)
#define _ADNBND (sizeof (acpi_native_int) - 1)
 
#define _bnd(X, bnd) (((sizeof (X)) + (bnd)) & (~(bnd)))
#define va_arg(ap, T) (*(T *)(((ap) += (_bnd (T, _AUPBND))) - (_bnd (T,_ADNBND))))
#define va_end(ap) (void) 0
#define va_start(ap, A) (void) ((ap) = (((char *) &(A)) + (_bnd (A,_AUPBND))))



char sprint_buf[1024];
int fprintf_(int fd, const char *fmt, ...)
{
    va_list args;
    int n, ret;
    
    va_start(args, fmt);
    n = vsprintf(sprint_buf, fmt, args);
    va_end(args);
    ret = pc_write(fd, sprint_buf, n);
    
    return ret;
}

void main(void)
{ 
    int fd,iRet; 
    int i;
    InitLib();
    if(pc_init())
		Print("Init microSD ok\n\r");
    else
    {
        Print("Init microSD failed\n\r");
        iRet=pc_get_errno();
        switch(iRet)
        {
            case PCERR_BAD_FORMAT: //1
                Print("Error 01: format is not FAT(FAT16)\n\r");
                break;
            case PCERR_NO_CARD: //2
                Print("Error 02: no microSD card\n\r");
                break;
            default:
                Print("Error %02d: check the error code list in microSD.h\n\r");
        }
        Delay(10); //wait 10 ms to let the message can be printed compeletely.
        exit(0);
    }
    
    fd=pc_open("test.txt",(word)(PO_WRONLY|PO_CREATE|PO_APPEND),(word)(PS_IWRITE|PS_IREAD));
    if(fd>=0)
    {
		// use fprintf_ to write format string data
		iRet = fprintf_(fd,"fprintf test %d, %s \n", i, "Hello World");
		Print("[%d] write %d bytes to test.txt, done.\n\r", i, iRet);
			
			
        pc_write(fd,"1234567890",10); //write 10 bytes
        pc_close(fd);
        Print("write 10 bytes to test.txt, done.\n\r");
    }
    else
    {
        iRet=pc_get_errno();
        Print("Error %02d: check the error code list in microSD.h\n\r",iRet);
    }
}